#ifndef CPPFTW_GTEST_EXTENSION_HPP
#define CPPFTW_GTEST_EXTENSION_HPP

#include <gtest/gtest.h>

#define MY_TEST_CLASS_NAME(test_case_name, test_name) test_case_name##test_name##_Test_my

#define MY_TEST(test_case_name, test_name, type, condition) \
    class MY_TEST_CLASS_NAME(test_case_name, test_name) { \
    public: \
        template<typename T = type, typename T2 = condition<T>>\
        static void TestBodyImpl(void*);\
        template<typename T = type>\
        static void TestBodyImpl(...) { FAIL(); }\
    }; \
    TEST(test_case_name, test_name) { MY_TEST_CLASS_NAME(test_case_name, test_name)::TestBodyImpl<type>(nullptr); } \
    template<typename type, typename> \
    void MY_TEST_CLASS_NAME(test_case_name, test_name)::TestBodyImpl(void*)

#define CPPFTW_HAS_GLOBAL(className, f, ...)                    \
    class className                                             \
    {                                                           \
        struct two_ints_type { int two_ints_1, two_ints_2; };   \
        template <typename... ARGS>                             \
        static auto test(void*)                                 \
            -> decltype((void)f(std::declval<ARGS>()...), 0);   \
        template <typename...>                                  \
        static two_ints_type& test(...);                        \
    public:                                                     \
        enum : bool { value =                                   \
            sizeof(test<__VA_ARGS__>(nullptr)) == sizeof(int) };\
    }


#endif //CPPFTW_GTEST_EXTENSION_HPP
